Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/SelfTest/src/top_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/SelfTest/src/top_deallocation.cpp	(revision 113)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/SelfTest/src/top_deallocation.cpp	(revision 113)
@@ -0,0 +1,28 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ * Test
+ */
+
+#include "Behavioural/Generic/Counter/SelfTest/include/top.h"
+#include "Behavioural/include/Allocation.h"
+
+void top::deallocation (void)
+{
+  cout << "<" << name << "> : Destruction of component" << endl;
+
+#ifdef SYSTEMC
+  delete             in_CLOCK;
+  DELETE0_SC_SIGNAL( in_NRESET);
+  DELETE1_SC_SIGNAL( in_COUNTER_DATA  ,param->_nb_port);
+  DELETE1_SC_SIGNAL( in_COUNTER_ADDSUB,param->_nb_port);
+  DELETE1_SC_SIGNAL(out_COUNTER_DATA  ,param->_nb_port);
+#endif
+
+  delete component;
+#ifdef STATISTICS
+  delete param_stat;
+#endif
+}
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/SelfTest/src/top_test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/SelfTest/src/top_test.cpp	(revision 113)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/SelfTest/src/top_test.cpp	(revision 113)
@@ -0,0 +1,82 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ * Test
+ */
+
+#include "Behavioural/Generic/Counter/SelfTest/include/top.h"
+
+void top::test (void)
+{
+#ifdef SYSTEMC
+  Time * _time = new Time();
+
+  /********************************************************
+   * Simulation - Begin
+   ********************************************************/
+
+  cout << "<" << name << "> Start Simulation ............" << endl;
+  // Initialisation
+
+  srand(0);
+  //srand(TIME(NULL));
+
+  Tdata_t    data_in  [param->_nb_port];
+  Tdata_t    data_out [param->_nb_port];
+  Tcontrol_t addsub   [param->_nb_port];
+
+  SC_CYCLE(0);
+
+  in_NRESET->write(1);
+
+  LABEL("Initialisation");
+
+  LABEL("Loop of Test");
+
+  for (uint32_t iteration=0; iteration<NB_ITERATION; iteration ++)
+    {
+      LABEL("Iteration %d",iteration);
+
+      for (uint32_t i=0; i<param->_nb_port; i++)
+	{
+	  Tdata_t data = rand()%param->_data_max;
+	  data_in  [i] = data;
+	  addsub   [i] = (rand()%2)==1; 
+	  
+          LABEL("in_COUNTER_DATA   [%d] = %d",i,data      );
+          LABEL("in_COUNTER_ADDSUB [%d] = %d"  ,i,addsub [i]);
+
+	  in_COUNTER_DATA   [i]->write(data      );
+	  in_COUNTER_ADDSUB [i]->write(addsub [i]);
+
+	  data_out [i] = (addsub[i]==1)?((data<param->_data_max)?data+1:data):((data>0)?data-1:data);
+	}
+
+      SC_CYCLE(0);
+
+      for (uint32_t i=0; i<param->_nb_port; i++)
+	{
+          string op = (addsub[i] == 1)?"++":"--";
+          LABEL("0x%d %s = 0x%d",i,op.c_str(),out_COUNTER_DATA [i]->read());
+
+	  TEST(Tdata_t,out_COUNTER_DATA [i]->read(),data_out [i]);
+	}
+      
+      SC_CYCLE(1);
+    }
+
+  SC_CYCLE(1);
+
+  /********************************************************
+   * Simulation - End
+   ********************************************************/
+
+  sc_stop();
+
+  delete _time;
+
+  cout << "<" << name << "> ............ Stop Simulation" << endl;
+#endif
+}
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/SelfTest/src/top_usage.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/SelfTest/src/top_usage.cpp	(revision 113)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/SelfTest/src/top_usage.cpp	(revision 113)
@@ -0,0 +1,18 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/Counter/SelfTest/include/top.h"
+
+void top::usage (string exec)
+{
+  cerr << "<Usage> " << exec << " name_instance list_params" << endl
+       << "list_params is :" << endl
+       << " - size_data     (unsigned int)" << endl
+       << " - nb_port       (unsigned int)" << endl;
+
+  exit (1);
+}
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/include/Counter.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/include/Counter.h	(revision 112)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/include/Counter.h	(revision 113)
@@ -40,7 +40,7 @@
     // -----[ fields ]----------------------------------------------------
     // Parameters
-  protected : const std::string _name;
-  protected : const Parameters  _param;
-  private   : const Tusage_t    _usage;
+  protected : const std::string   _name;
+  protected : const Parameters  * _param;
+  private   : const Tusage_t      _usage;
 
 #ifdef STATISTICS
@@ -79,8 +79,8 @@
 					   morpheo::behavioural::Parameters_Statistics * param_statistics,
 #endif
-					   Parameters param,
-					   Tusage_t   usage);
+					   Parameters * param,
+					   Tusage_t     usage);
 					       
-  public  :          Counter              (Parameters param );
+// public  :          Counter              (Parameters param );
   public  :          ~Counter             (void);
 					       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter.cpp	(revision 112)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter.cpp	(revision 113)
@@ -13,5 +13,6 @@
 namespace counter {
 
-
+#undef FUNCTION
+#define FUNCTION "Counter::Counter"
   Counter::Counter 
   (
@@ -24,5 +25,5 @@
   morpheo::behavioural::Parameters_Statistics * param_statistics,
 #endif
-  morpheo::behavioural::generic::counter::Parameters param,
+  morpheo::behavioural::generic::counter::Parameters * param,
    Tusage_t usage):
     _name  (name),
@@ -30,11 +31,11 @@
     _usage (usage)
   {
-    log_printf(FUNC,Counter,"Counter","Begin");
+    log_begin(Counter,FUNCTION);
 
-#if DEBUG_Counter == true
-    log_printf(INFO,Counter,FUNCTION,_("<%s> Parameters"),_name.c_str());
+// #if DEBUG_Counter == true
+//     log_printf(INFO,Counter,FUNCTION,_("<%s> Parameters"),_name.c_str());
 
-    std::cout << param << std::endl;
-#endif    
+//     std::cout << *param << std::endl;
+// #endif    
 
     log_printf(INFO,Core,FUNCTION,_("<%s> Allocation"),_name.c_str());
@@ -76,5 +77,5 @@
         SC_METHOD (genMealy);
         dont_initialize ();
-        for (uint32_t i=0; i<_param._nb_port; i++)
+        for (uint32_t i=0; i<_param->_nb_port; i++)
           sensitive << *(in_COUNTER_DATA   [i])
                     << *(in_COUNTER_ADDSUB [i]);
@@ -82,5 +83,5 @@
 #ifdef SYSTEMCASS_SPECIFIC
         // List dependency information
-        for (uint32_t i=0; i<_param._nb_port; i++)
+        for (uint32_t i=0; i<_param->_nb_port; i++)
           {
             (*(out_COUNTER_DATA [i])) (*(in_COUNTER_DATA   [i]));
@@ -91,10 +92,12 @@
 
 #endif
-    log_printf(FUNC,Counter,"Counter","End");
+    log_end(Counter,FUNCTION);
   };
   
+#undef FUNCTION
+#define FUNCTION "Counter::~Counter"
   Counter::~Counter (void)
   {
-    log_printf(FUNC,Counter,"~Counter","Begin");
+    log_begin(Counter,FUNCTION);
 
 #ifdef STATISTICS
@@ -108,5 +111,5 @@
     deallocation ();
 
-    log_printf(FUNC,Counter,"~Counter","End");
+    log_end(Counter,FUNCTION);
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_allocation.cpp	(revision 112)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_allocation.cpp	(revision 113)
@@ -21,5 +21,5 @@
 
     Entity * entity = _component->set_entity (_name     
-					     ,"Counter"  
+					     ,_param->_type
 #ifdef POSITION
 					     ,COMBINATORY
@@ -45,11 +45,11 @@
     // ~~~~~[ Interface : "counter" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC1_INTERFACE_BEGIN("counter", IN, SOUTH, _("Counter interface"), _param._nb_port);
+      ALLOC1_INTERFACE_BEGIN("counter", IN, SOUTH, _("Counter interface"), _param->_nb_port);
 	   
-      ALLOC1_SIGNAL_IN ( in_COUNTER_DATA  ,"data"  ,Tdata_t   ,_param._size_data);
+      ALLOC1_SIGNAL_IN ( in_COUNTER_DATA  ,"data"  ,Tdata_t   ,_param->_size_data);
       ALLOC1_SIGNAL_IN ( in_COUNTER_ADDSUB,"addsub",Tcontrol_t,1                );
-      ALLOC1_SIGNAL_OUT(out_COUNTER_DATA  ,"data"  ,Tdata_t   ,_param._size_data);
+      ALLOC1_SIGNAL_OUT(out_COUNTER_DATA  ,"data"  ,Tdata_t   ,_param->_size_data);
 
-      ALLOC1_INTERFACE_END(_param._nb_port);
+      ALLOC1_INTERFACE_END(_param->_nb_port);
     }
     
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_deallocation.cpp	(revision 112)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_deallocation.cpp	(revision 113)
@@ -24,7 +24,7 @@
         delete     in_NRESET;
         
-        DELETE1_SIGNAL( in_COUNTER_DATA  , _param._nb_port,_param._size_data);
-        DELETE1_SIGNAL( in_COUNTER_ADDSUB, _param._nb_port,1                );
-        DELETE1_SIGNAL(out_COUNTER_DATA  , _param._nb_port,_param._size_data);
+        DELETE1_SIGNAL( in_COUNTER_DATA  , _param->_nb_port,_param->_size_data);
+        DELETE1_SIGNAL( in_COUNTER_ADDSUB, _param->_nb_port,1                );
+        DELETE1_SIGNAL(out_COUNTER_DATA  , _param->_nb_port,_param->_size_data);
       }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_genMealy.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_genMealy.cpp	(revision 112)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_genMealy.cpp	(revision 113)
@@ -18,5 +18,5 @@
     log_printf(FUNC,Counter,"genMealy","Begin");
 
-    for (uint32_t i=0; i<_param._nb_port; i++)
+    for (uint32_t i=0; i<_param->_nb_port; i++)
       {
 	Tcontrol_t addsub  = PORT_READ(in_COUNTER_ADDSUB [i]);
@@ -28,5 +28,5 @@
 	if (addsub == 1)
 	  {
-	    if (data_out < _param._data_max)
+	    if (data_out < _param->_data_max)
 	      data_out++;
 	  }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_statistics_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_statistics_declaration.cpp	(revision 112)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_statistics_declaration.cpp	(revision 113)
@@ -21,5 +21,5 @@
 
     _stat = new Stat (static_cast<std::string>(_name),
-		      "Counter",
+		      _param->_type,
 		      param_statistics);
     
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_body.cpp	(revision 112)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_body.cpp	(revision 113)
@@ -19,9 +19,9 @@
     vhdl->set_body ("");
     
-    for (uint32_t i=0; i<_param._nb_port; i++)
+    for (uint32_t i=0; i<_param->_nb_port; i++)
       {
 	std::string counter_inc, counter_dec;
 
-	if (_param._size_data > 1)
+	if (_param->_size_data > 1)
 	  {
 	    counter_inc = "in_COUNTER_"+toString(i)+"_DATA+1";
@@ -35,5 +35,5 @@
 
 	vhdl->set_body ("out_COUNTER_"+toString(i)+"_DATA <=");
-	if (_param._size_data > 1)
+	if (_param->_size_data > 1)
 	  {
 	    vhdl->set_body ("\tin_COUNTER_"+toString(i)+"_DATA+1 when in_COUNTER_"+toString(i)+"_ADDSUB = '1' and in_COUNTER_"+toString(i)+"_DATA < cst_max else");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_declaration.cpp	(revision 112)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_declaration.cpp	(revision 113)
@@ -19,8 +19,8 @@
     log_printf(FUNC,Counter,"vhdl_declaration","Begin");
     
-    if (_param._size_data > 1)
+    if (_param->_size_data > 1)
       {
-	vhdl->set_constant ("cst_min",_param._size_data,std_logic_others(_param._size_data,0));
-	vhdl->set_constant ("cst_max",_param._size_data,std_logic_others(_param._size_data,1));
+	vhdl->set_constant ("cst_min",_param->_size_data,std_logic_others(_param->_size_data,0));
+	vhdl->set_constant ("cst_max",_param->_size_data,std_logic_others(_param->_size_data,1));
       }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Parameters.cpp	(revision 112)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Parameters.cpp	(revision 113)
@@ -16,4 +16,5 @@
   Parameters::Parameters (uint32_t size_data,
 			  uint32_t nb_port  ):
+    behavioural::Parameters("Counter"),
     _size_data(size_data),
     _nb_port  (nb_port  ),
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Divider/Makefile.defs
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Divider/Makefile.defs	(revision 112)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Divider/Makefile.defs	(revision 113)
@@ -7,4 +7,6 @@
 # 
 
+ENTITY                          = Divider
+
 #-----[ Directory ]----------------------------------------
 DIR_COMPONENT_MORPHEO		= ../../..
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Multiplier/Makefile.defs
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Multiplier/Makefile.defs	(revision 112)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Multiplier/Makefile.defs	(revision 113)
@@ -7,4 +7,6 @@
 # 
 
+ENTITY                          = Multiplier
+
 #-----[ Directory ]----------------------------------------
 DIR_COMPONENT_MORPHEO		= ../../..
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/Makefile.defs
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/Makefile.defs	(revision 112)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Priority/Makefile.defs	(revision 113)
@@ -7,4 +7,6 @@
 # 
 
+ENTITY                          = Priority
+
 #-----[ Directory ]----------------------------------------
 DIR_COMPONENT_MORPHEO		= ../../..
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/Makefile.defs
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/Makefile.defs	(revision 112)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/Makefile.defs	(revision 113)
@@ -2,10 +2,12 @@
 # $Id$
 # 
-# [ Description ]
+# [ Description ]
 # 
 # Makefile
 # 
 
-#-----[ Directory ]----------------------------------------
+ENTITY				= Queue
+
+#-----[ Directory ]----------------------------------------
 DIR_COMPONENT_MORPHEO		= ../../..
 DIR_MORPHEO			= $(DIR_COMPONENT)/$(DIR_COMPONENT_MORPHEO)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/include/top.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/include/top.h	(revision 113)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/include/top.h	(revision 113)
@@ -0,0 +1,77 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ * Test "Queue"
+ */
+
+#ifdef SYSTEMC
+#include "systemc.h"
+#endif
+
+#define NB_ITERATION  1
+#define CYCLE_MAX     (2048*NB_ITERATION)
+
+#include "Common/include/Test.h"
+#include "Common/include/Time.h"
+#include "Behavioural/Generic/Queue/include/Queue.h"
+
+using namespace std;
+using namespace morpheo;
+using namespace morpheo::behavioural;
+using namespace morpheo::behavioural::generic;
+
+using namespace morpheo::behavioural::generic::queue;
+
+void test    (string name,
+	      morpheo::behavioural::generic::queue::Parameters * param);
+
+SC_MODULE(top)
+{
+#ifdef SYSTEMC
+ private: sc_clock               *  in_CLOCK ;
+ private: sc_signal<Tcontrol_t>  *  in_NRESET;
+
+ private: sc_signal<Tcontrol_t>  *  in_INSERT_VAL;
+ private: sc_signal<Tcontrol_t>  * out_INSERT_ACK;
+ private: sc_signal<Tdata_t   >  *  in_INSERT_DATA;
+
+ private: sc_signal<Tcontrol_t>  * out_RETIRE_VAL;
+ private: sc_signal<Tcontrol_t>  *  in_RETIRE_ACK;
+ private: sc_signal<Tdata_t   >  * out_RETIRE_DATA;
+
+ private: sc_signal<Tcontrol_t> ** out_SLOT_VAL ; //[nb_port_slot]
+ private: sc_signal<Tdata_t   > ** out_SLOT_DATA; //[nb_port_slot]
+
+ private: sc_signal<Tptr_t    >  * out_PTR_WRITE;
+ private: sc_signal<Tptr_t    >  * out_PTR_READ ;
+#endif
+
+ private: std::string name;
+ private: Tusage_t _usage;
+ private: morpheo::behavioural::generic::queue::Parameters * _param;
+#ifdef STATISTICS
+ private: morpheo::behavioural::Parameters_Statistics * _param_stat;
+#endif
+ private: Queue * component;
+
+ private: void usage
+    (
+#ifdef MTI_SYSTEMC
+     int argc, const char * const * argv
+#else
+     int argc, char * argv[]
+#endif
+     );
+ private: void allocation   (void);
+ private: void deallocation (void);
+ public : void test         (void);
+
+#ifdef MTI_SYSTEMC
+  SC_CTOR(top::top);
+#else
+ public : top (sc_module_name module_name,int argc, char * argv[]);
+#endif
+ public : ~top(void);
+};
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/src/main.cpp	(revision 112)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/src/main.cpp	(revision 113)
@@ -2,73 +2,47 @@
  * $Id$
  *
- * [ Description ]
+ * [ Description ]
  * 
  */
 
-#include "Behavioural/Generic/Queue/SelfTest/include/test.h"
+#include "Behavioural/Generic/Queue/SelfTest/include/top.h"
 
-#define NB_PARAMS 5
+#ifndef MTI_SYSTEMC
+# ifndef SYSTEMC
+int main    (int argc, char * argv[])
+# else
+int sc_main (int argc, char * argv[])
+# endif
+{
+  int _return = EXIT_SUCCESS;
 
-void usage (int argc, char * argv[])
-{
-  cerr << "<Usage> " << argv[0] << " name_instance list_params" << endl
-       << "list_params is :" << endl
-       << " - size_queue      (uint32_t)" << endl
-       << " - size_data       (uint32_t)" << endl
-       << " - nb_port_slot    (uint32_t)" << endl
-       << " - have_port_write (bool    )" << endl
-       << " - have_port_read  (bool    )" << endl
-       << "" << endl;
-
-  for (int i=0; i<argc; i++)
-    cerr << argv[i] << " ";
-  cerr << endl;
-
-  exit (1);
-}
-
-#ifndef SYSTEMC
-int main    (int argc, char * argv[])
-#else
-int sc_main (int argc, char * argv[])
-#endif
-{
-  if (argc != 2+NB_PARAMS)
-    usage (argc, argv);
-
-  uint32_t       x = 1;
-  
-  const string   name            =      argv[x++];
-  const uint32_t size_queue      = fromString<uint32_t>(argv[x++]);
-  const uint32_t size_data       = fromString<uint32_t>(argv[x++]);
-  const uint32_t nb_port_slot    = fromString<uint32_t>(argv[x++]);
-  const bool     have_port_write = fromString<bool>(argv[x++]);
-  const bool     have_port_read  = fromString<bool>(argv[x++]);
   try 
     {
-      morpheo::behavioural::generic::queue::Parameters * param = new morpheo::behavioural::generic::queue::Parameters
-	(size_queue,
-	 size_data ,
-         nb_port_slot,
-         have_port_write,
-         have_port_read 
-        );
-      
-      cout << param->print(1);
-      
-      test (name,param);
+      top * my_top = new top ("my_top",argc,argv);
+
+      my_top->test();
+
+      delete my_top;
     }
   catch (morpheo::ErrorMorpheo & error)
     {
-      cout << "<" << name << "> : " <<  error.what ();
-      exit (EXIT_FAILURE);
+      msgError(_("%s\n"),error.what ());
+      _return = EXIT_FAILURE;
     }
-  catch (...)
+  
+  try 
     {
-      cerr << "<" << name << "> : This test must generate a error" << endl;
-      exit (EXIT_FAILURE);
+      if (_return == EXIT_SUCCESS)
+	TEST_OK("Queue : no error");
+      else
+	TEST_KO("Queue : a lot of error");
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+//    msgError(_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
     }
 
-  return (EXIT_SUCCESS);
+  return _return;
 }
-
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/src/top.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/src/top.cpp	(revision 113)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/src/top.cpp	(revision 113)
@@ -0,0 +1,74 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/Queue/SelfTest/include/top.h"
+#include "Behavioural/include/Selftest.h"
+
+#define NB_PARAMS 5
+
+#ifdef MTI_SYSTEMC
+SC_MODULE_EXPORT(top);
+#endif
+
+#ifdef MTI_SYSTEMC
+SC_CTOR(top::top)
+#else
+top::top (sc_module_name module_name, int argc, char * argv[])
+#endif
+{
+#ifdef MTI_SYSTEMC
+  // accessing command-line arguments with modelsim
+  int argc;
+  const char * const * argv;
+
+  argc = sc_argc ();
+  argv = sc_argv ();
+#endif
+
+  if (argc != 2+NB_PARAMS)
+    usage (argc, argv);
+
+  uint32_t size_queue     ;
+  uint32_t size_data      ;
+  uint32_t nb_port_slot   ;
+  bool     have_port_write;
+  bool     have_port_read ;
+
+  uint32_t x=1;
+
+  SELFTEST0(name           ,string  ,argv,x);
+  SELFTEST0(size_queue     ,uint32_t,argv,x);
+  SELFTEST0(size_data      ,uint32_t,argv,x);
+  SELFTEST0(nb_port_slot   ,uint32_t,argv,x);
+  SELFTEST0(have_port_write,bool    ,argv,x);
+  SELFTEST0(have_port_read ,bool    ,argv,x);
+
+  _param = new morpheo::behavioural::generic::queue::Parameters
+    (
+      size_queue
+     ,size_data 
+     ,nb_port_slot
+     ,have_port_write
+     ,have_port_read
+//   ,true
+     );
+  
+  // msg(_("%s"),_param.print(0).c_str());
+  
+  // Allocation component
+  allocation ();
+  
+#ifdef MTI_SYSTEMC
+  SC_THREAD(test);
+#endif
+}
+
+top::~top (void)
+{
+  deallocation ();
+  delete _param;
+}
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/src/top_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/src/top_allocation.cpp	(revision 113)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/src/top_allocation.cpp	(revision 113)
@@ -0,0 +1,101 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ * Test
+ */
+
+#include "Behavioural/Generic/Queue/SelfTest/include/top.h"
+#include "Behavioural/include/Allocation.h"
+
+void top::allocation (void)
+{
+  if (setlocale (LC_ALL, "") == NULL)
+    msgWarning(_("setlocale ko.\n"));
+
+  try 
+    {
+      _param->test();
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+      msgError(_("<%s> : %s"),name.c_str(),error.what());
+      return;
+    }
+  catch (...)
+    {
+      msgError(_("<%s> : This test must generate a error"),name.c_str());
+      exit (EXIT_FAILURE);
+    }
+
+  _usage = USE_ALL;
+//   _usage = usage_unset(_usage,USE_SYSTEMC              );
+//   _usage = usage_unset(_usage,USE_VHDL                 );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH       );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH_ASSERT);
+//   _usage = usage_unset(_usage,USE_POSITION             );
+//   _usage = usage_unset(_usage,USE_STATISTICS           );
+//   _usage = usage_unset(_usage,USE_INFORMATION          );
+
+#ifdef STATISTICS
+  if (usage_is_set(_usage,USE_STATISTICS))
+  _param_stat = new morpheo::behavioural::Parameters_Statistics (5,CYCLE_MAX);
+#endif
+
+  component = new Queue 
+    (name.c_str(),
+#ifdef STATISTICS
+     _param_stat,
+#endif
+     _param,
+     _usage
+     );
+  
+#ifdef SYSTEMC
+  if (usage_is_set(_usage,USE_SYSTEMC))
+    {
+  /*********************************************************************
+   * Déclarations des signaux
+   *********************************************************************/
+  msgInformation(_("<%s> : Create signal.\n"),name.c_str());
+
+  in_CLOCK  = new sc_clock ("clock", TIME_PERIOD, TIME_UNIT, 0.5); //name,period,time_unit,duty_cycle
+
+  ALLOC0_SC_SIGNAL( in_NRESET     ," in_NRESET"     ,Tcontrol_t);
+
+  ALLOC0_SC_SIGNAL( in_INSERT_VAL , "in_INSERT_VAL" ,Tcontrol_t);
+  ALLOC0_SC_SIGNAL(out_INSERT_ACK ,"out_INSERT_ACK" ,Tcontrol_t);
+  ALLOC0_SC_SIGNAL( in_INSERT_DATA, "in_INSERT_DATA",Tdata_t   );
+  ALLOC0_SC_SIGNAL(out_RETIRE_VAL ,"out_RETIRE_VAL" ,Tcontrol_t);
+  ALLOC0_SC_SIGNAL( in_RETIRE_ACK , "in_RETIRE_ACK" ,Tcontrol_t);
+  ALLOC0_SC_SIGNAL(out_RETIRE_DATA,"out_RETIRE_DATA",Tdata_t   );
+  ALLOC1_SC_SIGNAL(out_SLOT_VAL   ,"out_SLOT_VAL"   ,Tcontrol_t,_param->_nb_port_slot);
+  ALLOC1_SC_SIGNAL(out_SLOT_DATA  ,"out_SLOT_DATA"  ,Tdata_t   ,_param->_nb_port_slot);
+  ALLOC0_SC_SIGNAL(out_PTR_WRITE  ,"out_PTR_WRITE"  ,Tptr_t    );
+  ALLOC0_SC_SIGNAL(out_PTR_READ   ,"out_PTR_READ"   ,Tptr_t    );
+  
+  /********************************************************
+   * Instanciation
+   ********************************************************/
+  
+  msgInformation(_("<%s> : Instanciation of _Queue.\n"),name.c_str());
+
+  INSTANCE0_SC_SIGNAL(component, in_CLOCK);
+  INSTANCE0_SC_SIGNAL(component, in_NRESET);
+
+  INSTANCE0_SC_SIGNAL(component, in_INSERT_VAL );
+  INSTANCE0_SC_SIGNAL(component,out_INSERT_ACK );
+  INSTANCE0_SC_SIGNAL(component, in_INSERT_DATA);
+  INSTANCE0_SC_SIGNAL(component,out_RETIRE_VAL );
+  INSTANCE0_SC_SIGNAL(component, in_RETIRE_ACK );
+  INSTANCE0_SC_SIGNAL(component,out_RETIRE_DATA);
+  INSTANCE1_SC_SIGNAL(component,out_SLOT_VAL   ,_param->_nb_port_slot);
+  INSTANCE1_SC_SIGNAL(component,out_SLOT_DATA  ,_param->_nb_port_slot);
+  if (_param->_have_port_ptr_write)
+  INSTANCE0_SC_SIGNAL(component,out_PTR_WRITE  );
+  if (_param->_have_port_ptr_read )
+  INSTANCE0_SC_SIGNAL(component,out_PTR_READ   );
+    }
+#endif
+}
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/src/top_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/src/top_deallocation.cpp	(revision 113)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/src/top_deallocation.cpp	(revision 113)
@@ -0,0 +1,33 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ * Test
+ */
+#include "Behavioural/Generic/Queue/SelfTest/include/top.h"
+#include "Behavioural/include/Allocation.h"
+
+void top::deallocation (void)
+{
+#ifdef SYSTEMC
+  delete             in_CLOCK;
+  DELETE0_SC_SIGNAL( in_NRESET);
+
+  DELETE0_SC_SIGNAL( in_INSERT_VAL );
+  DELETE0_SC_SIGNAL(out_INSERT_ACK );
+  DELETE0_SC_SIGNAL( in_INSERT_DATA);
+  DELETE0_SC_SIGNAL(out_RETIRE_VAL );
+  DELETE0_SC_SIGNAL( in_RETIRE_ACK );
+  DELETE0_SC_SIGNAL(out_RETIRE_DATA);
+  DELETE1_SC_SIGNAL(out_SLOT_VAL   ,_param->_nb_port_slot);
+  DELETE1_SC_SIGNAL(out_SLOT_DATA  ,_param->_nb_port_slot);
+  DELETE0_SC_SIGNAL(out_PTR_WRITE  );
+  DELETE0_SC_SIGNAL(out_PTR_READ   );
+#endif
+
+  delete component;
+#ifdef STATISTICS
+  delete _param_stat;
+#endif
+}
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/src/top_test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/src/top_test.cpp	(revision 113)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/SelfTest/src/top_test.cpp	(revision 113)
@@ -0,0 +1,102 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ * Test
+ */
+
+#include "Behavioural/Generic/Queue/SelfTest/include/top.h"
+#include "Behavioural/include/Allocation.h"
+
+void top::test (void)
+{
+#ifdef SYSTEMC
+  if (usage_is_set(_usage,USE_SYSTEMC))
+    {
+      msgInformation(_("<%s> : Start Simulation ............\n"),name.c_str());
+      
+      Time * _time = new Time();
+      
+      /********************************************************
+       * Simulation - Begin
+       ********************************************************/
+      
+      // Initialisation
+      const  int32_t percent_insert_transaction = 75;
+      const  int32_t percent_retire_transaction = 75;
+      const uint32_t nb_request = 3*_param->_size_queue;
+      
+      const uint32_t seed = 0;
+      //const uint32_t seed = static_cast<uint32_t>(time(NULL));
+      
+      srand(seed);
+      
+      SC_CYCLE(0);
+      LABEL("Initialisation");
+      
+      in_INSERT_VAL -> write(0);
+      in_RETIRE_ACK -> write(0);
+      
+      LABEL("Reset");
+      in_NRESET->write(0);
+      SC_CYCLE(5);
+      in_NRESET->write(1);  
+      
+      LABEL("Loop of Test");
+      
+      uint32_t data_in  = 0;
+      uint32_t data_out = 0;
+      uint32_t nb_elt   = 0;
+      
+      for (uint32_t iteration=0; iteration<NB_ITERATION; iteration ++)
+        {
+          LABEL("Iteration %d",iteration);
+          
+          while (data_out <= nb_request)
+            {
+              in_INSERT_VAL  -> write((rand()%100)<percent_insert_transaction);
+              in_INSERT_DATA -> write(data_in);
+              in_RETIRE_ACK  -> write((rand()%100)<percent_retire_transaction);
+              
+              SC_CYCLE(0); // genMoore
+              
+              for (uint32_t i=0; i<_param->_nb_port_slot; ++i)
+                {
+                  TEST(Tcontrol_t, out_SLOT_VAL [i]->read(), (i<nb_elt));
+                  if (i<nb_elt)
+                    TEST(Tdata_t   , out_SLOT_DATA[i]->read(), data_out+i);
+                  
+                }
+              
+              if ( in_INSERT_VAL->read() and out_INSERT_ACK->read())
+                {
+                  LABEL ("Transaction with interface : INSERT");
+                  data_in ++;
+                  nb_elt ++;
+                }
+              if (out_RETIRE_VAL->read() and  in_RETIRE_ACK->read())
+                {
+                  LABEL ("Transaction with interface : RETIRE");
+                  TEST(Tdata_t, out_RETIRE_DATA->read(), data_out);
+                  data_out++;
+                  nb_elt --;
+                }
+              
+              SC_CYCLE(1);
+            }
+        }
+      
+      /********************************************************
+       * Simulation - End
+       ********************************************************/
+      
+      TEST_OK ("");
+      
+      sc_stop();
+      delete _time;
+      
+      msgInformation(_("<%s> : ............ Stop Simulation\n"),name.c_str());
+    }
+#endif
+}
